Loading...
Searching...
No Matches
BALL::CrystalInfo Class Reference
Molecular Modeling » X-Ray Crystallography

`#include <BALL/XRAY/crystalInfo.h>`

Inheritance diagram for BALL::CrystalInfo:

## Classes

struct | Option
struct | Default

## Public Member Functions

Constructors and Destructor
| CrystalInfo ()
| CrystalInfo (String group, Vector3 dim, Angle alpha, Angle beta, Angle gamma)
| CrystalInfo (const CrystalInfo &ci)
| ~CrystalInfo ()
bool | setSpaceGroup (const String &sg)
const String & | getSpaceGroup () const
void | setCellDimensions (const Vector3 &dim)
void | setCellEdgeLengthA (const float &a)
const float & | getCellEdgeLengthA () const
void | setCellEdgeLengthB (const float &b)
const float & | getCellEdgeLengthB () const
void | setCellEdgeLengthC (const float &c)
const float & | getCellEdgeLengthC () const
void | setCellAngles (const Angle &alpha, const Angle &beta, const Angle &gamma)
void | setCellAngleAlpha (const Angle &alpha)
const Angle & | getCellAngleAlpha () const
void | setCellAngleBeta (const Angle &beta)
const Angle & | getCellAngleBeta () const
void | setCellAngleGamma (const Angle &gamma)
const Angle & | getCellAngleGamma () const
void | setZScore (const int &zscore)
const int & | getZScore () const
Size | getNumberOfSymOps () const
const Matrix4x4 & | getSymOp (Position p) const
Size | getNumberOfNCSSymOps () const
const Matrix4x4 & | getNCS (Position p) const
Matrix4x4 & | getNCS (Position p)
bool | isgivenNCS (Position p) const
bool | insertNCS (Position p, Matrix4x4 ncsm, bool is_given=0)
void | pushbackNCS (Matrix4x4 ncsm, bool is_given=0)
bool | eraseNCS (Position p)
const Matrix4x4 & | getCart2Frac () const
const Matrix4x4 & | getFrac2Cart () const
void | setDefaultOptions ()
Public Member Functions inherited from BALL::PersistentObject
| PersistentObject ()
virtual | ~PersistentObject ()
PersistenceManager & | operator>> (PersistenceManager &pm) const
virtual void | finalize ()
Public Member Functions inherited from BALL::Object
| Object ()
| Default constructor.
| Object (const Object &object)
| Copy constructor.
virtual | ~Object ()
| Destructor.
virtual void | clear ()
| Clear function of the OCI, doing nothing here.
const Object & | operator= (const Object &)
bool | operator== (const Object &object) const
bool | operator!= (const Object &object) const
bool | operator< (const Object &object) const
bool | operator<= (const Object &object) const
bool | operator>= (const Object &object) const
bool | operator> (const Object &object) const
int | compare (const Object &object) const
virtual bool | isValid () const
virtual void | dump (::std::ostream &s=std::cout, Size depth=0) const
Handle | getHandle () const
Public Member Functions inherited from BALL::AutoDeletable
virtual | ~AutoDeletable ()
void * | operator new (size_t size)
void | operator delete (void *ptr)
void * | operator new (size_t size, void *ptr)
void | operator delete (void *ptr, void *)
bool | isAutoDeletable () const
void | setAutoDeletable (bool enable)

## Public Attributes

Public Attributes
Options | options
| options

## Storable Interface

String | space_group_
Vector3 | cell_dimensions_
Angle | alpha_
Angle | beta_
Angle | gamma_
int | z_score_
String | filename_
Matrix4x4 | cart2frac_
Matrix4x4 | frac2cart_
vector< Matrix4x4 > | ncs_symops_
vector< bool > | ncs_isgiven_
vector< Matrix4x4 > | sg_symops_
void | persistentWrite (PersistenceManager &pm, const char *name) const
void | persistentRead (PersistenceManager &pm)
void | calculateMatrices_ ()
bool | retrieveSymOps_ (const String &sg)

## Additional Inherited Members

static Handle | getNextHandle ()
static Handle | getNewHandle ()
static void | clearLastPtr ()
| AutoDeletable ()
| AutoDeletable (const AutoDeletable &auto_deletable, bool deep=false)

## Detailed Description

CrystalInfo class.

Definition at line 40 of file crystalInfo.h.

## Constructor & Destructor Documentation

## CrystalInfo() [1/3]

BALL::CrystalInfo::CrystalInfo | ( |  | ) |

Default constructor

## CrystalInfo() [2/3]

BALL::CrystalInfo::CrystalInfo | ( | String | group,
|  | Vector3 | dim,
|  | Angle | alpha,
|  | Angle | beta,
|  | Angle | gamma )

Detailed Constructor

## CrystalInfo() [3/3]

BALL::CrystalInfo::CrystalInfo | ( | const CrystalInfo & | ci | ) |

Copy Constructor

## ~CrystalInfo()

BALL::CrystalInfo::~CrystalInfo | ( |  | ) |

Default Constructor

## Member Function Documentation

## calculateMatrices_()

void BALL::CrystalInfo::calculateMatrices_ | ( |  | ) |

protected

## eraseNCS()

bool BALL::CrystalInfo::eraseNCS | ( | Position | p | ) |

Erase an NCS

Exceptions

  Exception::IndexOverflow | if p >= getNumberOfNCSSymOps()

## getCart2Frac()

const Matrix4x4 & BALL::CrystalInfo::getCart2Frac | ( |  | ) | const

## getCellAngleAlpha()

const Angle & BALL::CrystalInfo::getCellAngleAlpha | ( |  | ) | const

## getCellAngleBeta()

const Angle & BALL::CrystalInfo::getCellAngleBeta | ( |  | ) | const

## getCellAngleGamma()

const Angle & BALL::CrystalInfo::getCellAngleGamma | ( |  | ) | const

## getCellEdgeLengthA()

const float & BALL::CrystalInfo::getCellEdgeLengthA | ( |  | ) | const

## getCellEdgeLengthB()

const float & BALL::CrystalInfo::getCellEdgeLengthB | ( |  | ) | const

## getCellEdgeLengthC()

const float & BALL::CrystalInfo::getCellEdgeLengthC | ( |  | ) | const

## getFrac2Cart()

const Matrix4x4 & BALL::CrystalInfo::getFrac2Cart | ( |  | ) | const

## getNCS() [1/2]

Matrix4x4 & BALL::CrystalInfo::getNCS | ( | Position | p | ) |

Returns a mutable reference to the p-th NCS

Exceptions

  Exception::IndexOverflow | if p >= getNumberOfNCSSymOps()

## getNCS() [2/2]

const Matrix4x4 & BALL::CrystalInfo::getNCS | ( | Position | p | ) | const

Returns the p-th NCS

Exceptions

  Exception::IndexOverflow | if p >= getNumberOfNCSSymOps()

## getNumberOfNCSSymOps()

Size BALL::CrystalInfo::getNumberOfNCSSymOps | ( |  | ) | const

## getNumberOfSymOps()

Size BALL::CrystalInfo::getNumberOfSymOps | ( |  | ) | const

## getSpaceGroup()

const String & BALL::CrystalInfo::getSpaceGroup | ( |  | ) | const

## getSymOp()

const Matrix4x4 & BALL::CrystalInfo::getSymOp | ( | Position | p | ) | const

## getZScore()

const int & BALL::CrystalInfo::getZScore | ( |  | ) | const

## insertNCS()

bool BALL::CrystalInfo::insertNCS | ( | Position | p,
|  | Matrix4x4 | ncsm,
|  | bool | is_given = 0 )

Insert an NCS

Exceptions

  Exception::IndexOverflow | if p >= getNumberOfNCSSymOps()

## isgivenNCS()

bool BALL::CrystalInfo::isgivenNCS | ( | Position | p | ) | const

Returns true is the p-th NCS is given

Exceptions

  Exception::IndexOverflow | if p >= getNumberOfNCSSymOps()

## persistentRead()

void BALL::CrystalInfo::persistentRead | ( | PersistenceManager & | pm | ) |

virtual

Persistent stream reading.

Reimplemented from BALL::PersistentObject.

## persistentWrite()

void BALL::CrystalInfo::persistentWrite | ( | PersistenceManager & | pm,
|  | const char * | name ) const

virtual

Persistent stream writing.

Reimplemented from BALL::PersistentObject.

## pushbackNCS()

void BALL::CrystalInfo::pushbackNCS | ( | Matrix4x4 | ncsm,
|  | bool | is_given = 0 )

## retrieveSymOps_()

bool BALL::CrystalInfo::retrieveSymOps_ | ( | const String & | sg | ) |

protected

## setCellAngleAlpha()

void BALL::CrystalInfo::setCellAngleAlpha | ( | const Angle & | alpha | ) |

## setCellAngleBeta()

void BALL::CrystalInfo::setCellAngleBeta | ( | const Angle & | beta | ) |

## setCellAngleGamma()

void BALL::CrystalInfo::setCellAngleGamma | ( | const Angle & | gamma | ) |

## setCellAngles()

void BALL::CrystalInfo::setCellAngles | ( | const Angle & | alpha,
|  | const Angle & | beta,
|  | const Angle & | gamma )

## setCellDimensions()

void BALL::CrystalInfo::setCellDimensions | ( | const Vector3 & | dim | ) |

## setCellEdgeLengthA()

void BALL::CrystalInfo::setCellEdgeLengthA | ( | const float & | a | ) |

## setCellEdgeLengthB()

void BALL::CrystalInfo::setCellEdgeLengthB | ( | const float & | b | ) |

## setCellEdgeLengthC()

void BALL::CrystalInfo::setCellEdgeLengthC | ( | const float & | c | ) |

## setDefaultOptions()

void BALL::CrystalInfo::setDefaultOptions | ( |  | ) |

Resets the options to default values.

## setSpaceGroup()

bool BALL::CrystalInfo::setSpaceGroup | ( | const String & | sg | ) |

## setZScore()

void BALL::CrystalInfo::setZScore | ( | const int & | zscore | ) |

## Member Data Documentation

## alpha_

Angle BALL::CrystalInfo::alpha_

protected

Definition at line 197 of file crystalInfo.h.

## beta_

Angle BALL::CrystalInfo::beta_

protected

Definition at line 197 of file crystalInfo.h.

## cart2frac_

Matrix4x4 BALL::CrystalInfo::cart2frac_

protected

Definition at line 201 of file crystalInfo.h.

## cell_dimensions_

Vector3 BALL::CrystalInfo::cell_dimensions_

protected

Definition at line 196 of file crystalInfo.h.

## filename_

String BALL::CrystalInfo::filename_

protected

Definition at line 199 of file crystalInfo.h.

## frac2cart_

Matrix4x4 BALL::CrystalInfo::frac2cart_

protected

Definition at line 202 of file crystalInfo.h.

## gamma_

Angle BALL::CrystalInfo::gamma_

protected

Definition at line 197 of file crystalInfo.h.

## ncs_isgiven_

vector<bool> BALL::CrystalInfo::ncs_isgiven_

protected

Definition at line 205 of file crystalInfo.h.

## ncs_symops_

vector<Matrix4x4> BALL::CrystalInfo::ncs_symops_

protected

Definition at line 204 of file crystalInfo.h.

## options

Options BALL::CrystalInfo::options

options

Definition at line 162 of file crystalInfo.h.

## sg_symops_

vector<Matrix4x4> BALL::CrystalInfo::sg_symops_

protected

Definition at line 206 of file crystalInfo.h.

## space_group_

String BALL::CrystalInfo::space_group_

protected

Reads, checks and stores the options.

Returns
  bool - false if one of the options got an invalid value.
  bool - true otherwise

Definition at line 195 of file crystalInfo.h.

## z_score_

int BALL::CrystalInfo::z_score_

protected

Definition at line 198 of file crystalInfo.h.